// ================================================================================================+
//                 =====              HistoryDraw.mq4                      =====                   |
//             =============          Copyright  2012, Drknn          =============               |
//                 =====              mailto: drknn@mail.ru                =====                   |
// ================================================================================================+

#include <SignalStatement.mqh>

#property copyright "Copyright  2012, Drknn"
#property link      "drknn@mail.ru"
string		NameExpert="HistoryDraw.mq4";

extern bool	UseCreateHistoryDraw=true;//       
extern bool	UseDelHistoryDraw=true;/*       
																			.   UseCreateHistoryDraw  
																			false,  ,     UseDelHistoryDraw
																		*/


int    myBars;



// ================================================================================================+
// ================================================================================================|
//             =============                     =============               |
// ================================================================================================|
// ================================================================================================+
int init(){
	Print(" ",NameExpert,"   ",Symbol(),"  -   ");
	return(0);
}



// ================================================================================================+
// ================================================================================================|
//            =============                   =============                |
// ================================================================================================|
// ================================================================================================+
int deinit(){

	if(!IsTesting()){
		string s_Deint;
		switch(UninitializeReason()){
			case 0:		s_Deint="    "; break;
			case 1:		s_Deint="     ,       ,     "; break;
			case 2:		s_Deint=" "; break;
			case 3:		s_Deint="     "; break;
			case 4:		s_Deint=" "; break;
			case 5:		s_Deint="    "; break;
			case 6:		s_Deint="  "; break;
			default:	s_Deint="   "; break;
		}
		if(UseCreateHistoryDraw && UseDelHistoryDraw){
			HistoryDrawDelete();
		}
		Print(" ",NameExpert,"   ",Symbol()," . : ",s_Deint);
		Comment("");
	}
	return(0);
}



// ================================================================================================+
// ================================================================================================|
//           =============                        =============                |
// ================================================================================================|
// ================================================================================================+
int start(){

	// ===============================================================================================
	// =======================     =========================================
	// ===============================================================================================
		if(isNewBar() && UseCreateHistoryDraw){
			HistoryDrawCreate();
		}
	// ===============================================================================================


	return(0);
}
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  isNewBar() -                                                  |
//+------------------------------------------------------------------+
bool isNewBar(){
  bool res=false;
  if(myBars!=Bars){
    res=true;
    myBars=Bars;
  }
	return(res);
}
//---------------------------------------------------------------

// -------------------------- HistoryDrawCreate() --------------------------------------------------
//      
// --------------------------------------------------------
void HistoryDrawCreate(){
  string	FunctionName="HistoryDrawDelete()";
	string SMB=Symbol();
  double OpenBuy=0.0,CloseBuy=0.0,OpenSell=0.0,CloseSell=0.0;// 
  int Ticket;
  string L_name,Tip,Open_name,Close_name;
  datetime TimeOpenBuy=0,TimeCloseBuy=0,TimeOpenSell=0,TimeCloseSell=0;
  for(int i=0; i<S._OrdersHistoryTotal(); i++){
    if (!S._OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
			Print("  ",GetLastError(),"     ",i);
			Print(" ============== ",FunctionName," ============== ");
		}
    else{
			if(S._OrderSymbol()!=SMB){continue;}
			if(S._OrderType()==OP_BUY){
			// -------------    --------------
				OpenBuy=S._OrderOpenPrice();
				CloseBuy=S._OrderClosePrice();
				Ticket=S._OrderTicket();
				TimeOpenBuy=S._OrderOpenTime();
				TimeCloseBuy=S._OrderCloseTime();
				// ----    ------
				Tip="Buy";// 
				L_name="L_"+Tip+"  "+Ticket;
				Open_name="Open"+Tip+"  "+Ticket;//,  
				Close_name="Close"+Tip+"  "+Ticket;//,  
				// ----    ------------
				ObjectCreate(Open_name,OBJ_ARROW,0,TimeOpenBuy,OpenBuy);//  -
				ObjectSet(Open_name,OBJPROP_ARROWCODE,1);//  232
				ObjectSet(Open_name,OBJPROP_COLOR,Blue);// 
				// ----    ------------
				ObjectCreate(Close_name,OBJ_ARROW,0,TimeCloseBuy,CloseBuy);//  -
				ObjectSet(Close_name,OBJPROP_ARROWCODE,3);//   231
				ObjectSet(Close_name,OBJPROP_COLOR,Blue);// 
				// ----   ------------
				ObjectCreate(L_name,OBJ_TREND,0,TimeOpenBuy,OpenBuy,TimeCloseBuy,CloseBuy);//
				ObjectSet(L_name,OBJPROP_RAY,false);//  
				ObjectSet(L_name,OBJPROP_WIDTH,0);//   ()
				ObjectSet(L_name,OBJPROP_STYLE,0);//   ()
				ObjectSet(L_name,OBJPROP_STYLE,STYLE_DOT);//  ( )
				ObjectSet(L_name,OBJPROP_COLOR,Blue);// (/)
			}
			if(S._OrderType()==OP_SELL){
				// -------------    ------------
				OpenSell=S._OrderOpenPrice();
				CloseSell=S._OrderClosePrice();
				Ticket=S._OrderTicket();
				TimeOpenSell=S._OrderOpenTime();
				TimeCloseSell=S._OrderCloseTime();
				// ----    ------
				Tip="Sell";// 
				L_name="L_"+Tip+"  "+Ticket;
				Open_name="Open"+Tip+"  "+Ticket;//,  
				Close_name="Close"+Tip+"  "+Ticket;//,  
				// ----    ------------
				ObjectCreate(Open_name,OBJ_ARROW,0,TimeOpenSell,OpenSell);//  Sell-
				ObjectSet(Open_name,OBJPROP_ARROWCODE,1);//  232
				ObjectSet(Open_name,OBJPROP_COLOR,Red);// 
				// ----    ------------
				ObjectCreate(Close_name,OBJ_ARROW,0,TimeCloseSell,CloseSell);//  Sell-
				ObjectSet(Close_name,OBJPROP_ARROWCODE,3);//   231
				ObjectSet(Close_name,OBJPROP_COLOR,Red);// 

				// ----   ------------
				ObjectCreate(L_name,OBJ_TREND,0,TimeOpenSell,OpenSell,TimeCloseSell,CloseSell);//
				ObjectSet(L_name,OBJPROP_RAY,false);//  
				ObjectSet(L_name,OBJPROP_WIDTH,0);//   ()
				ObjectSet(L_name,OBJPROP_STYLE,0);//   ()
				ObjectSet(L_name,OBJPROP_STYLE,STYLE_DOT);//  ( )
				ObjectSet(L_name,OBJPROP_COLOR,Red);// (/)
			}
		}
	}
}

// -------------------------- HistoryDrawDelete() --------------------------------------------------
//    ,   
// --------------------------------------------------------
void HistoryDrawDelete(){
	string	FunctionName="HistoryDrawDelete()";
	string SMB=Symbol();
	double OpenBuy=0.0,CloseBuy=0.0,OpenSell=0.0,CloseSell=0.0;// 
  int Ticket;
  string L_name,Tip,Open_name,Close_name;
  datetime TimeOpenBuy=0,TimeCloseBuy=0,TimeOpenSell=0,TimeCloseSell=0;
  for(int i=0;i<S._OrdersHistoryTotal();i++){
		if(!S._OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
			Print("  ",GetLastError(),"     ",i);
			Print(" ============== ",FunctionName," ============== ");
		}
		else{
			if(S._OrderSymbol()!=SMB){continue;}
			if(S._OrderType()==OP_BUY){
				// -------------    --------------
				OpenBuy=S._OrderOpenPrice();
				CloseBuy=S._OrderClosePrice();
				Ticket=S._OrderTicket();
				TimeOpenBuy=S._OrderOpenTime();
				TimeCloseBuy=S._OrderCloseTime();
				// ----    ------
				Tip="Buy";// 
				L_name="L_"+Tip+"  "+Ticket;
				Open_name="Open"+Tip+"  "+Ticket;//,  
				Close_name="Close"+Tip+"  "+Ticket;//,  
				// ----    ------------
				ObjectDelete(Open_name);//  -
				// ----    ------------
				ObjectDelete(Close_name);//  -
				// ----   ------------
				ObjectDelete(L_name);//
			}
			if(S._OrderType()==OP_SELL){
				// -------------    ------------
				OpenSell=S._OrderOpenPrice();
				CloseSell=S._OrderClosePrice();
				Ticket=S._OrderTicket();
				TimeOpenSell=S._OrderOpenTime();
				TimeCloseSell=S._OrderCloseTime();
				// ----    ------
				Tip="Sell";// 
				L_name="L_"+Tip+"  "+Ticket;
				Open_name="Open"+Tip+"  "+Ticket;//,  
				Close_name="Close"+Tip+"  "+Ticket;//,  
				// ----    ------------
				ObjectDelete(Open_name);//  Sell-
				// ----    ------------
				ObjectDelete(Close_name);//  Sell-
				// ----   ------------
				ObjectDelete(L_name);//
			}
		}
  }
}